=== debian/changelog ===
ros-kinetic-acado (1.2.2-0xenial) xenial; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Ronald Ensing <r.m.ensing@tudelft.nl>  Mon, 11 Mar 2019 10:01:13 -0000
