=== debian/control ===
Source: ros-kinetic-acado
Section: misc
Priority: extra
Maintainer: Ronald Ensing <r.m.ensing@tudelft.nl>
Build-Depends: debhelper (>= 9.0.0), cmake, libboost-all-dev
Homepage: http://acado.github.io/
Standards-Version: 3.9.2

Package: ros-kinetic-acado
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, ros-kinetic-catkin
Description: ACADO Toolkit
